=== src/thirdparty/CMakeLists.txt ===
###########################################################################
#   Free Heroes of Might and Magic II: https://github.com/ihhub/fheroes2  #
#   Copyright (C) 2022                                                    #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
###########################################################################

if(USE_SYSTEM_LIBSMACKER)
	include(FindPkgConfig)

	pkg_check_modules(smacker REQUIRED smacker)
else(USE_SYSTEM_LIBSMACKER)
	set(
		LIBSMACKER_SOURCES
		libsmacker/smacker.c
		)

	add_library(smacker STATIC ${LIBSMACKER_SOURCES})

	target_include_directories(
		smacker
		PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/libsmacker>
		$<INSTALL_INTERFACE:include>
		)

	target_link_libraries(
		smacker
		Threads::Threads # To match the build settings of the main app
		)

	export(TARGETS smacker FILE SmackerConfig.cmake)
endif(USE_SYSTEM_LIBSMACKER)
