=== src/tools/Makefile ===
###########################################################################
#   Free Heroes of Might and Magic II: https://github.com/ihhub/fheroes2  #
#   Copyright (C) 2021 - 2022                                             #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
###########################################################################

TARGETS := extractor 82m2wav til2img icn2img xmi2mid_cli bin2txt

LIBENGINE := ../engine/libengine.a
CCFLAGS := $(CCFLAGS) -I../engine

.PHONY: all clean

all: $(TARGETS)

$(TARGETS): $(addsuffix .cpp, $(TARGETS)) $(LIBENGINE)
	$(CXX) $(CCFLAGS) $(CXXFLAGS) -c $@.cpp
	$(CXX) $(LDFLAGS) $@.o $(LIBENGINE) $(LIBS) -o $@

clean:
	rm -f *.o *.exe $(TARGETS)
