=== script/packaging/debian/changelog ===
fheroes2 (0.9.15-1) UNRELEASED; urgency=medium

  * Initial release

 -- fheroes2 team <fhomm2@gmail.com>  Sat, 07 Apr 2022 00:00:00 +0000
