=== script/packaging/debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_CFLAGS_MAINT_APPEND = -DFHEROES2_DATA=/usr/share/games/fheroes2

%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build
	make -C files/lang
